program gebrauchte_autos;

uses    crt,printer;

const   max = 100;           {+++Maximale Eingabe an Autos+++}

type    auto  =  record
                   nummer       :  byte;
                   katalysator  :  string[1];
                   marke,modell :  string[30];
                   baujahr      :  integer;
                   km           :  longint;
                   preis        :  real;
                   ausstattung  :  string[30];
                             {+++z.B.Radio,Fensterheber,Winterreifen+++}
                 end;
var     platz       :  array[0..100] of auto;  	        {+++Gruppe von Autos+++}
        tauschvar   :  auto;				{+++Hilfsarry zum Tauschen+++}
        tauschint   :  auto;				{+++Hilfsarry zum Tauschen+++}
        auswahl,nr  :  integer;
        n,k,g       :  integer;
        datei       :  file of auto;
        ch          :  char;

procedure rahmen;

const   wa=#196;						{+++waagerechte Linie+++}
        se=#179;						{+++senkrechte Linie+++}

var     i,j,alte_farbe : integer;

begin
        clrscr;
        alte_farbe:=textattr;
        textcolor(green);
        textbackground(white);
        gotoxy(2,2);for i:=1 to 74 do write(wa);
        for j:=2 to 24 do
          begin
            gotoxy(2,j);write(se);
          end;
        for i:=2 to 24 do
          begin
            gotoxy(75,i);write(se);
          end;
        for j:=3 to 74 do
          begin
            gotoxy(j,24);write(wa);
          end;

end; {+++Rahmen+++}

procedure taste;

begin
     repeat until keypressed; ch:=readkey;
end;

procedure ankauf;            {+++Eingabe der Datenstze+++}

begin

     nr:=1;
     gotoxy(27,3);textcolor(red);writeln('+++++++Ankauf+++++++');
     while (nr<>max) and (platz[nr].preis <> 0) do nr:=nr+1;
     if platz[nr].preis<>0 then
        begin
             gotoxy(27,5);textcolor(black);
             writeln('Es ist kein Platz mehr frei');
             gotoxy(45,7);writeln('Fertig ?   <Taste>');
             taste;
        end else
        begin
             gotoxy(20,8);textcolor(black);write('Platz   ',nr,'  ist frei');
             gotoxy(20,10);textcolor(red);write('Bitte Autodaten eingeben');
             gotoxy(20,12);textcolor(black);write('Katalysator vorhanden ? ');
                                 readln(platz[nr].katalysator);
             gotoxy(20,13);write('Marke              ');readln(platz[nr].marke);
             gotoxy(20,14);write('Modell             ');readln(platz[nr].modell);
             gotoxy(20,15);write('Baujahr            ');readln(platz[nr].baujahr);
             gotoxy(20,16);write('km-Stand           ');readln(platz[nr].km);
             gotoxy(20,17);write('Preis              ');readln(platz[nr].preis);
             gotoxy(20,18);write('Ausstattung        ');readln(platz[nr].ausstattung);
             gotoxy(20,20);textcolor(green);write('Die Nummer des Platzes  ',nr:4);
             gotoxy(40,23);textcolor(red);write('Fertig ?   <Taste>  ');
             taste;
        end;

end; {+++Ankauf+++}


procedure verkauf;           {+++Lschen eines Datensatzes+++}

begin
     gotoxy(27,3);textcolor(red);writeln('+++++++Verkauf+++++++');
     gotoxy(27,4);textcolor(black);writeln('Datensatz wird gelscht');
     gotoxy(27,19);textcolor(green);write('Platznummer eingeben  ');readln(nr);
     platz[nr].preis:=0;
end;  {+++verkauf+++}


procedure drucken;

begin
     writeln(lst);writeln(lst);writeln(lst);
     writeln(lst,'       Platznummer   ',nr:4);
     write  (lst,'       Marke         ',platz[nr].marke);
            if platz[nr].katalysator='j' then writeln(lst,'  mit Katalysator  ')
            else Writeln(lst,'         ohne Katalysator');
     writeln(lst,'       Modell        ',platz[nr].modell);
     writeln(lst,'       Baujahr       ',platz[nr].baujahr);
     writeln(lst,'       km-Stand      ',platz[nr].km);
     writeln(lst,'       Preis         ',platz[nr].preis);
     writeln(lst,'       Ausstattung   ',platz[nr].ausstattung);
     writeln(lst);writeln(lst);
     writeln(lst,'----------------------------------------');
     writeln(lst);
end;  {+++drucken+++}


procedure speichern;

begin

     rewrite(datei);              	{+++Legt stets eine neue leere Datei an und ffnet diese zum Schreiben+++}
						{+++ d.h. wenn eine Datei unter diesem Namen existiert+++}
						{+++ gehen alle vorher gespeicherten Daten verloren+++}
     for nr:=1 to max do
         if platz[nr].preis<>0 then
            begin
                 platz[nr].nummer:=nr;
                 write(datei,platz[nr]);
            end;
     close(datei);
end;  {+++speichern+++}


procedure laden;

begin
     reset(datei);           {+++Erffnen der  Datei zum Lesen+++}
     while not eof(datei) do {+++EOF prft, ob der Postionszeiger auf dem Dateiende steht+++}
           begin
                read(datei,platz[0]);
                nr:=platz[0].nummer;
                platz[nr]:=platz[0];
           end;
     close(datei);
end; {+++Laden+++}

{+++++++++++++++++++++SORTIEREN+++++BUBBLESORT++++++++++++++++++++++++}

procedure sortieren_Marke;

begin
     	reset(Datei);    
	g:=filesize(datei);     {+++Liefert die Gre einer Datei+++}
     	for nr:=1 to g-1 do
          for k:=nr+1 to g do
               if platz[k].marke < platz[nr].marke then
                      begin
                        tauschvar:=platz[nr];
                        platz[nr]:=platz[k];
                        platz[k]:=tauschvar;
                      end;


     gotoxy(20,3);write('Autoliste sortiert nach Marken:');
     gotoxy(20,4);write('*******************************');
     textcolor(green);
     gotoxy(3,6); write('Marke');gotoxy(15,6);write('Modell');gotoxy(27,6);write('km-Stand');
     gotoxy(39,6);write('Baujahr');gotoxy(49,6);write('Preis');textcolor(black);

      for nr:=1 to g do
      begin
      gotoxy(3,6+nr);write(platz[nr].marke);gotoxy(15,nr+6);write(platz[nr].modell);
      gotoxy(27,nr+6);write(platz[nr].km);gotoxy(39,nr+6);write(platz[nr].Baujahr);
      gotoxy(49,nr+6);write(platz[nr].preis:8:2);
      end;
      gotoxy(30,20);textcolor(134);write('Fertig ? <Taste> '); Taste;

end;  {+++Ende Sortieren nach Modellen+++}


procedure sortieren_preis;

var z :  integer;

begin
     reset(Datei);
     g:=filesize(datei);
     for nr:=1 to g-1 do
         for k:=nr+1 to g do
             if platz[nr].preis > platz[k].preis then
                      begin
                        tauschint:=platz[k];
                        platz[k]:=platz[nr];
                        platz[nr]:=tauschint;
                      end;

     gotoxy(20,3);write('Autoliste sortiert nach Preisen:');
     gotoxy(20,4);write('*******************************');
     textcolor(green);
     gotoxy(3,6); write('Preis');gotoxy(15,6);write('Marke');gotoxy(27,6);write('Modell');
     gotoxy(39,6);write('km-Stand');gotoxy(54,6);write('Baujahr');textcolor(black);

     for nr:=1 to g do
      begin
       gotoxy(3,6+nr);write(platz[nr].preis:10:2);gotoxy(15,nr+6);write(platz[nr].marke);
       gotoxy(27,nr+6);write(platz[nr].modell);gotoxy(39,nr+6);write(platz[nr].km);
       gotoxy(54,nr+6);write(platz[nr].baujahr);
      end;
     gotoxy(30,20);textcolor(red);write('Fertig ? <Taste> '); Taste;

end;  {+++Ende Sortieren nach Preisen+++}


procedure suchen;

var    autowunsch  :  auto;
       gefunden    :  boolean;
       druck       :  string[1];
       w,u         :  integer;

begin
     gotoxy(27,4);textcolor(red);write('+++++++Suchen+++++++');
     gotoxy(20,6);textcolor(black);write('Ist Katalysator Bedingung ? j/n    ');
     readln(autowunsch.katalysator);
     gotoxy(20,7); write('Marke ?    <?>eingeben, falls egal   ');readln(autowunsch.marke);
     gotoxy(20,8); write('Modell ?   <?>eingeben, falls egal   ');readln(autowunsch.modell);
     gotoxy(20,9); write('frhestes Baujahr :                  ');readln(autowunsch.baujahr);
     gotoxy(20,10);write('Maximale km :                        ');readln(autowunsch.km);
     gotoxy(20,11);write('Maximaler Preis :                    ');readln(autowunsch.preis);
     gefunden:=false;

     for nr:=1 to max do
         if Platz[nr].preis<>0 then
            if (autowunsch.katalysator='n') or (autowunsch.katalysator=platz[nr].katalysator)then
             if(autowunsch.marke='?') or (autowunsch.marke=platz[nr].marke) then
              if(autowunsch.modell='?') or (autowunsch.modell=platz[nr].modell) then
               if(autowunsch.baujahr<=platz[nr].baujahr)then
                if(autowunsch.preis>=platz[nr].preis) then
                 if(autowunsch.km>=platz[nr].km) then
                  begin
                       for w:=1 to 80 do
                       for u:=13 to 25 do begin textcolor(white);gotoxy(w,u);write(' ');end;
                       textcolor(black);
                       gotoxy(20,13);write('Platz  ',nr:4,platz[nr].marke);
                       if platz[nr].katalysator='j' then
                    begin gotoxy(28,14);write('mit Katalysator')
                    end else
                    begin
                     gotoxy(28,14);write('ohne Katalysator'); end;
                     gotoxy(20,15);write('Modell  :        ',platz[nr].modell);
                     gotoxy(20,16);write('Baujahr :        ',platz[nr].baujahr);
                     gotoxy(20,17);write('km-Stand:        ',platz[nr].km);
                     gotoxy(20,18);write('Preis   :        ',platz[nr].preis:10:2);
                     gotoxy(20,19);write('Extra   :        ',platz[nr].ausstattung);
                     gefunden:=true;
                     gotoxy(30,20);textcolor(red);write('Drucken ? j/n   ');readln(druck);
                      if druck='j' then drucken;
                    end;
     if gefunden=false then
     begin
          gotoxy(20,13);write('Der gesuchte Wagentyp ist zur Zeit nicht vorhanden')
     end  else
     begin
          gotoxy(20,20);textcolor(green);
          write('Mehr Autos nach ihren Wnschen sind nicht vorhanden          ');
     end;
     gotoxy(30,21);textcolor(red);write('Fertig ? <Taste>  ');taste;
end;  {+++suchen+++}


procedure menue;

begin
     rahmen;
     gotoxy(27,3);textcolor(red);write('+++++GEBRAUCHTE AUTOS+++++');
     gotoxy(20,7);textcolor(black);write('1 ___ Ankauf eines Autos');
     gotoxy(20,9); write('2 ___ Verkauf eines Autos');
     gotoxy(20,11);write('3 ___ Suchen eines Autos');
     gotoxy(20,13);write('4 ___ Laden');
     gotoxy(20,15);write('5 ___ Speichern');
     gotoxy(25,17);write('6 ___ Sortierte Liste nach Modellen');
     gotoxy(25,19);write('7 ___ Sortierte Liste nach Preisen');
     gotoxy(20,21);write('8 ___ ENDE');
     gotoxy(30,24);textcolor(red);write('Whle aus :  ');
end;  {+++menue+++}


{++++++++++HAUPTPROGRAMM++++++++++}


begin

     assign(datei, 'auto.dat');			{+++Ordnet einer Dateivariablen die tatschliche Datei zu+++}
					{+++Alle weiteren Befehle beziehen sich ber die Dateivariable auf diese Datei+++}
     for nr:=1 to max do platz[nr].preis:=0;
     repeat
           menue;
           readln(auswahl);
           clrscr;
           case auswahl of
           1    :       ankauf;
           2    :       verkauf;
           3    :       suchen;
           4    :       laden;
           5    :       speichern;
           6    :       sortieren_marke;
           7    :       sortieren_preis;
           end;
     until auswahl=8;
     clrscr;rahmen;
     gotoxy(22,13);textcolor(red);write('Danke fr die Benutzung des Programms');
     gotoxy(22,15);textcolor(red);write('(C) www.stephie-schmidt.de');
     readln;
end .

